local M = {}

--STROBE LIGHT SYSTEM STAGES--
local mainStrobeStage0 = {
    electric = "flash",
    duration = 0.75,
    value = 0,
    valueEnd = 0
}

local mainStrobeStage1 = {
    electric = "flash",
    duration = 0.22,
    value = 1,
    valueEnd = 0
}

local mainStrobeStage2 = {
    electric = "flash",
    duration = 0.05,
    value = 0,
    valueEnd = 0
}

local redStrobeStage0 = {
    electric = "redflash",
    duration = 0.75,
    value = 0,
    valueEnd = 0
    
}

local redStrobeStage1 = {
    electric = "redflash",
    duration = 0.22,
    value = 1,
    valueEnd = 0
}

local greenStrobeStage0 = {
    electric = "greenflash",
    duration = 0.75,
    value = 0,
    valueEnd = 0
}

local greenStrobeStage1 = {
    electric = "greenflash",
    duration = 0.22,
    value = 1,
    valueEnd = 0
}
--STROBE LIGHT SYSTEM STAGES END--
--STROBE LIGHT SYSETM DATA--
local currentStrobeStage = 1
local currentStrobeStageTime = 0
local strobeStages = {redStrobeStage0,redStrobeStage1,greenStrobeStage0,greenStrobeStage1,mainStrobeStage0,mainStrobeStage1,mainStrobeStage2,mainStrobeStage1}
--STROBE LIGHT SYSETM DATA END--

local function onInit()
	electrics.values['407rotorrpm'] = 0
    electrics.values['altitude'] = 0
    electrics.values['altitude100'] = 0
    electrics.values['altitude1000'] = 0
    electrics.values['flash'] = 0
    electrics.values['aspd'] = 0
    electrics.values['heading'] = 0
    electrics.values['roll'] = 0

end

local function updateGFX(dt)
  --STROBE SYSTEM--
  currentStrobeStageTime = currentStrobeStageTime + dt
  local lowbeamsOn = (electrics.values["lowhighbeam"] == 1)
  if lowbeamsOn then
    if currentStrobeStageTime > strobeStages[currentStrobeStage].duration then
        electrics.values[strobeStages[currentStrobeStage].electric] = strobeStages[currentStrobeStage].valueEnd
        currentStrobeStage = currentStrobeStage + 1
        if currentStrobeStage > #strobeStages then currentStrobeStage = 1 end
        electrics.values[strobeStages[currentStrobeStage].electric] = strobeStages[currentStrobeStage].value
        currentStrobeStageTime = 0
    end
  else
    for k,strb in pairs(strobeStages) do
        electrics.values[strb.electric] = 0
    end
  end
  --STROBE SYSTEM END--

  local pos = obj:getPosition()
  local velo = obj:getVelocity():length()
  local hdg = obj:getDirection() * -57.2958
  local dirVector = obj:getDirectionVector()
  local dirVectorUp = obj:getDirectionVectorUp()
  local roll = dirVectorUp.x * -dirVector.y + dirVectorUp.y * dirVector.x

  electrics.values['heading'] = (hdg) % 360
  electrics.values['roll'] = roll * 57.2958
  electrics.values['407rotorrpm'] = powertrain.getDevice("mainEngine").outputAV1 / 2100
  electrics.values['altitude100'] = (pos.z * 3.28084) % 1000
  electrics.values['altitude1000'] = (pos.z * 3.28084) % 10000
  electrics.values['altitude'] = (pos.z * 3.28084)
  electrics.values['aspd'] = (velo * 1.94384) - 15 / 4
end

local function reset()
 reset()
end

M.updateGFX = updateGFX
M.reset = reset
M.onInit = onInit
return M